﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class BallController : MonoBehaviour {

    const float CAN_RE_THROW_SPEED = 15.0f;

    [SerializeField]
    Rigidbody rigidBody;

    [SerializeField]
    InputManager inputManager;

    [SerializeField]
    GameParameter gameParameter;

    [SerializeField]
    float ballZValue;

    [SerializeField]
    DeathBlowPlayer deathBlow;

    Vector3 prevMousePosition;
    [SerializeField]
    bool throwflag = false;
    [SerializeField]
    bool canthrow = true;

	// Use this for initialization.
	void Start () {

        inputManager.SetExecInputPressMethod(ExecuteSetBallPosition);
        inputManager.SetExecInputDownMethod(ExecuteBallInitialize);
        inputManager.SetExecInputReleaseMethod(ExecuteThrowBall);
        inputManager.SetExecInputDeathBlowMethod(ActiveDeathBlow);
	}

	// Update is called once per frame.
	void Update () {

        //投げたボール
        if (canthrow) {
            //ボールのvelocity.zが一定以上
            if (rigidBody.velocity.z >= CAN_RE_THROW_SPEED)
            {
            //再投できない
                canthrow = false;
            }
        }

        //止まったときは次のゲーム(あとで)
	}

    //void OnTriggerEnter(Collision collision)
    //{
    //    //canthrow = false;
    //    //if (collision.gameObject == GameObject.Find("throwDecideCube"))
    //    //{
    //        //キューブに当たったらもう投げなおしはできない
    //        canthrow = false;
    //    //}
    //}

    private void ExecuteBallInitialize()
    {
        if (!canthrow) return;

        rigidBody.velocity = Vector3.zero;
        Debug.Log("ボール初期化");
    }

    private void ExecuteSetBallPosition() {
        if (!canthrow) return;



        if (!throwflag) {
            prevMousePosition = Input.mousePosition;
            prevMousePosition.x -= Screen.width*0.5f;
            prevMousePosition.y -= Screen.height*0.5f;
            throwflag = true;
        }

        var throwPosition = Input.mousePosition;
        throwPosition.x -= Screen.width*0.5f;
        throwPosition.y -= Screen.height*0.5f;

        //prevMousePosition.y = 0;
        //throwPosition.y = 0;
        throwPosition -= prevMousePosition;
        throwPosition *= 0.01f;
        throwPosition.y *= gameParameter.HeightScrollPercentage;
        throwPosition.y += 0.7f;
        //throwPosition.y = 0.7f;

        var ballPosition = transform.position;
        SetThrowPosition(throwPosition);

        prevMousePosition = throwPosition;
    }

    private void ExecuteThrowBall() {
        if (!canthrow) return;

        var force = inputManager.GetFlickDirection();
        force *= gameParameter.PlayerPower;
        ThrowBall(force);
        throwflag = false;
        //canthrow = false;
    }


    public void SetThrowPosition(Vector3 throwPosition) {
        if (!canthrow) return;

        throwPosition.z = ballZValue;
        transform.position = throwPosition;
    }


    private void ThrowBall(Vector3 force) {

        rigidBody.AddForce(force);
    }

    public void ActiveDeathBlow()
    {
        if (gameParameter.DeathBlowCredit >= 1)
        {
            deathBlow.Play();
        }
        gameParameter.DeathBlowCredit--;
    }

    //ボール再配置のときに呼ぶ
    public void CanThrowOn() {
        canthrow = true;
    }
}





