﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class MissionManager : MonoBehaviour
{

    enum MissionDefine
    {

        MAX_MISSION = 3,
    };

    public delegate bool MissionMethod();
    Dictionary<int, MissionMethod> missionList = new Dictionary<int,MissionMethod>();
    Dictionary<int, bool> missionCompletedList = new Dictionary<int, bool>();
    //int[] execMissionList = new int[3]; // C#の配列がわけわからんので、とりあえずDictionaryにすることに。
    Dictionary<int, int> execMissionList = new Dictionary<int,int>();
    Dictionary<int, string> missionsColumn = new Dictionary<int, string>();
    int missionNumber = 0;
    int execMissionNumber = 0;

    [SerializeField]
    bool isMission = false;


    // Use this for initialization.
    void Start()
    {

    }

    // Update is called once per frame.
    void Update()
    {

        if (!isMission)
        {
            return;
        }

        for (int index = 0; index < execMissionNumber; index++)
        {
            if (execMissionList[index] > missionNumber)
            {
                Debug.Log("不明な値がミッションとして設定されています。");
                continue;
            }

            if (missionCompletedList[execMissionList[index]]) {
                continue;
            }

            var isSuccess = missionList[execMissionList[index]]();
            Debug.Log("ミッション成功かどうか確認中...");

            if (isSuccess)
            {
                missionCompletedList[execMissionList[index]] = isSuccess;
                Debug.Log("ミッション成功!! : ミッション番号->" + execMissionList[index]);
            }

        }

    }

    public void StartMission()
    {
        isMission = true;
    }

    public void RegistryMissionAddMissionColumn(MissionMethod method, string missionColumn)
    {
        missionsColumn[missionNumber] = missionColumn;
        RegistryMission(method);
    }

    public void RegistryMission(MissionMethod method)
    {
        missionList[missionNumber] = method;
        missionCompletedList[missionNumber] = false;
        missionNumber++;
        Debug.Log("ミッション登録");
        Debug.Log(missionNumber);
    }

    void RemoveMission(int missionIndex)
    { 
        // 仮置き
    }

    void RemoveExecMission(int missionIndex)
    {
        // 仮置き
    }

    public void RegistryExecuteMissionNumber(int[] execMissionNumbers, int missionNumber)
    {
        execMissionNumber = missionNumber;
        Debug.Log("実行ミッション登録"); 
        Debug.Log(execMissionNumber);

        Debug.Log("実行ミッション番号");
        for(int index = 0; index < missionNumber; index++ ){

            execMissionList[index] = execMissionNumbers[index];
            Debug.Log(execMissionList[index]);
        }
    }

    public int ExecNextMissionAll()
    {
        for (int index = 0; index < missionNumber; index++ )
        {
            if (WhetherOrNotMissionSucceededAll(index)) {
                continue;
            }
            RegistryExecuteMissionNumber(new int[] { index }, 1);
            return index;
        }
        return -1;
    }

    public int ExecNextMission()
    {
        for (int index = 0; index < execMissionNumber; index++)
        {
            if (WhetherOrNotMissionSucceededExec(index))
            {
                continue;
            }
            RegistryExecuteMissionNumber(new int[] { index }, 1);
            return index;
        }
        return -1;
    }

    public int GetMissionNumber()
    {
        return missionNumber;
    }

    public bool WhetherOrNotMissionSucceededExec(int index)
    {
        return missionCompletedList[execMissionList[index]];
    }

    public bool WhetherOrNotMissionSucceededAll(int index)
    {
        return missionCompletedList[index];
    }

    public int GetExecutingMissionNumber() 
    {
        return execMissionNumber;
    }

    public string GetExecMissionColums(int index)
    {
        return missionsColumn[execMissionList[index]];
    }






}
