﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class MissionViewer : MonoBehaviour {


    [SerializeField]
    MissionManager missionManager;

    [SerializeField]
    Text missionColumn;

    [SerializeField]
    InputManager inputManager;

    int missionIndex = 0;

	// Use this for initialization
	void Start () {

        missionManager.StartMission();
        inputManager.SetExecInputMissionWidgetButton(CloseMission);
	}
	
	// Update is called once per frame
	void Update () {
        WriteMissionColumn();
	}

    void WriteMissionColumn()
    {
        var column = missionManager.GetExecMissionColums(missionIndex);
        missionColumn.text = column;    
    }

    public void ChangeMissionIndex(int index)
    {
        missionIndex = index;
    }

    public void ShowMission() 
    {
        this.gameObject.SetActive(true);
    }

    public void CloseMission()
    {
        this.gameObject.SetActive(false);
    }


}
