﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.SceneManagement;

public class OptionController : MonoBehaviour {


    public float hSliderValue = 0.0f;
    float moveHeightPercentage;
    float playerPower;

    [SerializeField]
    GameParameter gameParameter;

    [SerializeField]
    InputManager inputManager;

    [SerializeField]
    Button closeWidgetButton;

    [SerializeField]
    Button quitGameButton; 

    [SerializeField]
    AudioClip audio;

	// Use this for initialization
	void Start () {

        moveHeightPercentage = gameParameter.HeightScrollPercentage;
        playerPower = gameParameter.PlayerPower;

        inputManager.SetExecInputOpenOptionWindow(ShowWidget);
        closeWidgetButton.onClick.AddListener(CloseWidget);
        quitGameButton.onClick.AddListener(ToTitle);

        CloseWidget();
		
	}
	
	// Update is called once per frame
	void Update () {

        gameParameter.HeightScrollPercentage = moveHeightPercentage;
        gameParameter.PlayerPower = playerPower;
		
	}
    
    void OnGUI () {

        var screenCenter = new Vector2(Screen.width * 0.5f, Screen.height * 0.5f);
        var screenHeightSplitDecaple = Screen.height * 0.05f;
        var barSize = Screen.width * 0.7f;
        var barLeftPosition = Screen.width * 0.15f;

        GUI.Label(new Rect(barLeftPosition, screenCenter.y - screenHeightSplitDecaple * 3, barSize, barSize*0.2f), "MoveHightPercentage :" + moveHeightPercentage);
        moveHeightPercentage = GUI.HorizontalSlider(new Rect(barLeftPosition, screenCenter.y - screenHeightSplitDecaple * 2, barSize, barSize * 0.2f), moveHeightPercentage, 0.0f, 1.0f);

        GUI.Label(new Rect(barLeftPosition, screenCenter.y - screenHeightSplitDecaple * 1, barSize, barSize*0.2f), "PlayerPower:" + playerPower);
        playerPower = GUI.HorizontalSlider(new Rect(barLeftPosition, screenCenter.y, barSize, barSize * 0.2f), playerPower, 0.0f, 500.0f);

        GUI.Label(new Rect(barLeftPosition, screenCenter.y + screenHeightSplitDecaple * 1, barSize, barSize*0.2f), "Volume :" + hSliderValue);
        hSliderValue = GUI.HorizontalSlider(new Rect(barLeftPosition, screenCenter.y + screenHeightSplitDecaple * 2, barSize, barSize * 0.2f), hSliderValue, 0.0f, 1.0f);

    }

    void ToTitle() {

        SceneManager.LoadScene("Title");
    }

    public void ShowWidget()
    {
        this.gameObject.SetActive(true);
    }

    void CloseWidget()
    {
        this.gameObject.SetActive(false);  
    }

}
