﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class UIController : MonoBehaviour {

    [SerializeField]
    Button menuOpenButton;

    [SerializeField]
    Button activeDeathblowButton;

    [SerializeField]
    Button gatterOnOffButton;

    [SerializeField]
    Button helperButton;

    [SerializeField]
    Button showScoreBoardButton;

    [SerializeField]
    //Text strike;
    Image strike;
    bool bstrike = false;

    [SerializeField]
    Text combo;
    int ncombo;

    [SerializeField]
    Text score;
    [SerializeField]
    GameParameter gameParameter;

    [SerializeField]
    OptionController optionController;

    [SerializeField]
    BallController ballController;

    [SerializeField]
    GameObject gatterLane;
    [SerializeField]
    bool gatterOnOff = false;

    [SerializeField]
    bool helperOnOff = false;

	// Use this for initialization
	void Start () {

        menuOpenButton.onClick.AddListener(optionController.ShowWidget);
        activeDeathblowButton.onClick.AddListener(ballController.ActiveDeathBlow);
        showScoreBoardButton.onClick.AddListener(optionController.ShowWidget);
        helperButton.onClick.AddListener(optionController.ShowWidget);
        gatterOnOffButton.onClick.AddListener(ControlGatterLane);
		
        //
        gatterOnOff = gatterOnOff ^ true;
        ControlGatterLane();

	}
	
	// Update is called once per frame
	void Update () {


        //ストライク画像の表示
        strike.gameObject.SetActive(bstrike);
            
        //エフェクト?


        combo.text = "Combo : " + ncombo;
        score.text  = "UserScore : "+gameParameter.UserScore;

	}

    void ControlGatterLane()
    {

        gatterOnOff = gatterOnOff^true;
        gatterLane.SetActive(gatterOnOff);
        
    }

    public void SetCombo(int nCom){
        ncombo = nCom;
    }

    public void SetDrawStrike(bool b) {
        bstrike = b;
    }

}
